# Interface SyThemeValuesBuilderType

public interface SyThemeValuesBuilderType
A mutable builder to construct value sets.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `SyThemeValuesType`
  `create()`
  `SyThemeValuesBuilderType`
  `createConstantColor4D(String name, String description, com.io7m.jtensors.core.parameterized.vectors.PVector4D<SySpaceRGBAPreType> value)`
  Create a new named constant with an RGBA color type.
  `SyThemeValuesBuilderType`
  `createConstantDouble(String name, String description, double value)`
  Create a new named constant with a double type.
  `SyThemeValuesBuilderType`
  `createConstantFont(String name, String description, SyFontDescription value)`
  Create a new named constant with a font type.
  `SyThemeValuesBuilderType`
  `createConstantInteger(String name, String description, int value)`
  Create a new named constant with an integer type.
  `SyThemeValuesBuilderType`
  `createFunctionColor4D(String name, String description, String source, SyThemeValueFunctionType<com.io7m.jtensors.core.parameterized.vectors.PVector4D<SySpaceRGBAPreType>> value)`
  Create a new named function that transforms RGBA color types.
  `SyThemeValuesBuilderType`
  `createFunctionDouble(String name, String description, String source, SyThemeValueFunctionType<Double> value)`
  Create a new named function that transforms doubles.
  `SyThemeValuesBuilderType`
  `createFunctionFont(String name, String description, String source, SyThemeValueFunctionType<SyFontDescription> value)`
  Create a new named function that transforms fonts.
  `SyThemeValuesBuilderType`
  `createFunctionInteger(String name, String description, String source, SyThemeValueFunctionType<Integer> value)`
  Create a new named function that transforms integers.

- ## Method Details

  - ### createConstantColor4D

    SyThemeValuesBuilderType createConstantColor4D(String name, String description, com.io7m.jtensors.core.parameterized.vectors.PVector4D<SySpaceRGBAPreType> value) throws SyThemeValueException
    Create a new named constant with an RGBA color type.
    Parameters:
      `name` - The name
      `description` - The humanly-readable description
      `value` - The value
    Returns:
      this
    Throws:
      `SyThemeValueException` - On errors

  - ### createConstantInteger

    SyThemeValuesBuilderType createConstantInteger(String name, String description, int value) throws SyThemeValueException
    Create a new named constant with an integer type.
    Parameters:
      `name` - The name
      `description` - The humanly-readable description
      `value` - The value
    Returns:
      this
    Throws:
      `SyThemeValueException` - On errors

  - ### createConstantFont

    SyThemeValuesBuilderType createConstantFont(String name, String description, SyFontDescription value) throws SyThemeValueException
    Create a new named constant with a font type.
    Parameters:
      `name` - The name
      `description` - The humanly-readable description
      `value` - The value
    Returns:
      this
    Throws:
      `SyThemeValueException` - On errors

  - ### createConstantDouble

    SyThemeValuesBuilderType createConstantDouble(String name, String description, double value) throws SyThemeValueException
    Create a new named constant with a double type.
    Parameters:
      `name` - The name
      `description` - The humanly-readable description
      `value` - The value
    Returns:
      this
    Throws:
      `SyThemeValueException` - On errors

  - ### createFunctionColor4D

    SyThemeValuesBuilderType createFunctionColor4D(String name, String description, String source, SyThemeValueFunctionType<com.io7m.jtensors.core.parameterized.vectors.PVector4D<SySpaceRGBAPreType>> value) throws SyThemeValueException
    Create a new named function that transforms RGBA color types.
    Parameters:
      `name` - The name
      `description` - The humanly-readable description
      `source` - The name of the source that will be passed to this function
      `value` - The value
    Returns:
      this
    Throws:
      `SyThemeValueException` - On errors

  - ### createFunctionInteger

    SyThemeValuesBuilderType createFunctionInteger(String name, String description, String source, SyThemeValueFunctionType<Integer> value) throws SyThemeValueException
    Create a new named function that transforms integers.
    Parameters:
      `name` - The name
      `description` - The humanly-readable description
      `source` - The name of the source that will be passed to this function
      `value` - The value
    Returns:
      this
    Throws:
      `SyThemeValueException` - On errors

  - ### createFunctionDouble

    SyThemeValuesBuilderType createFunctionDouble(String name, String description, String source, SyThemeValueFunctionType<Double> value) throws SyThemeValueException
    Create a new named function that transforms doubles.
    Parameters:
      `name` - The name
      `description` - The humanly-readable description
      `source` - The name of the source that will be passed to this function
      `value` - The value
    Returns:
      this
    Throws:
      `SyThemeValueException` - On errors

  - ### createFunctionFont

    SyThemeValuesBuilderType createFunctionFont(String name, String description, String source, SyThemeValueFunctionType<SyFontDescription> value) throws SyThemeValueException
    Create a new named function that transforms fonts.
    Parameters:
      `name` - The name
      `description` - The humanly-readable description
      `source` - The name of the source that will be passed to this function
      `value` - The value
    Returns:
      this
    Throws:
      `SyThemeValueException` - On errors

  - ### create

    SyThemeValuesType create()
    Returns:
      An value set based on all of the parameters given so far